using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CompNetwork.BL;

public partial class Browse_Controls_ucProductDetails : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        DataSet ds;
        Int32 PID;
        if (!Page.IsPostBack)
        {
            lblMsg.Text = "";
            if (Request["PID"] != null)
            {
                if (Int32.TryParse(Request["PID"], out PID))
                {
                    ds = ProductController.GetProductDetailsByProductID(PID);
                    if (ds.Tables[0].Rows.Count == 0)
                    {
                        lblMsg.Text = "No Products available with this ID.";
                        dlProduct.Visible = false;
                    }
                    else
                    {
                        dlProduct.DataSource = ds;
                        dlProduct.DataBind();
                        dlProduct.Visible = true;
                    }
                }
                else
                {
                    lblMsg.Text = "Invalid Category ID.";
                }
            }
            else
            {
                lblMsg.Text = "Category ID Not Provided.";
            }
        }
    }
    protected void dlProduct_ItemCommand(object source, DataListCommandEventArgs e)
    {
        Int32 PID=0,Qty=1;
        decimal price=0,offerprice=0,actualprice=0;
        string SID=Session.SessionID;
        Session["SID"] = SID;
        Object obj;
        Label lbl;
        //Obtaining product ID.
        obj = e.Item.FindControl("lblPID");
        if (obj != null)
        {
            lbl = (Label)obj;
            PID = Int32.Parse(lbl.Text);
        }

        //Obtaining product Price.
        obj = e.Item.FindControl("lblPrice");
        if (obj != null)
        {
            lbl = (Label)obj;
            price = decimal.Parse(lbl.Text.Replace("$",""));
        }

        //Obtaining product Offer Price.
        obj = e.Item.FindControl("lblOfferPrice");
        if (obj != null)
        {
            lbl = (Label)obj;
            offerprice = decimal.Parse(lbl.Text.Replace("$", ""));
        }
        if (price > offerprice && offerprice>0)
            actualprice = offerprice;
        else
            actualprice = price;

        if (e.CommandName == "Buy")
        {
            try
            {
                ShoppingCart.AddCartItem(Session["SID"].ToString(), PID, actualprice, Qty);
                Response.Redirect("~/cart/frmShoppingCart.aspx?SID=" + Session["SID"].ToString());
            }
            catch (Exception ex)
            {
                lblMsg.Text = ex.Message;
            }
        }
        else 
        {
            if (e.CommandName == "RateProduct")
            {
                Response.Redirect(string.Format("~/Browse/frmRateProduct.aspx?PID={0}",PID));
            }
            else 
            {
                if (e.CommandName == "AddToWishList")
                {
                    Response.Redirect(string.Format("~/Browse/frmAddWishList.aspx?PID={0}", PID.ToString()));
                }
                else
                {
                    if (e.CommandName == "ReferToFriend")
                    {
                        Response.Redirect("~/Browse/frmReferToFriend.aspx");
                    }  
                }
            }
        }
    }
    protected void dlProduct_ItemDataBound(object sender, DataListItemEventArgs e)
    {
        if (e.Item.DataItem != null)
        {
            DataRowView drv = (DataRowView)e.Item.DataItem;
            int avgrating = int.Parse(drv["AverageRating"].ToString());
            if (avgrating > 5)
                avgrating = 5;
            Literal lit = null;
            object obj = e.Item.FindControl("LtlAvgRating");
            if (obj != null)
            {
                lit = (Literal)obj;
                int x = 0;
                string rating1="";
                for (x = 1; x <= avgrating; x++)
                {
                    rating1 = rating1 + "<img src='/EPostalServicesNetwork/Browse/images/1star.gif' alt=" + avgrating.ToString() + ">";
                }
                for (x = avgrating; x <= 5; x++)
                {
                    rating1 = rating1 + "<img src='/EPostalServicesNetwork/Browse/images/nostar.gif' alt=" + avgrating.ToString() + ">";
                }
                lit.Text = rating1;
            }

            Label lblPrice=null, lblOfferPrice=null,lblTitleOfferPrice=null;
            float price=0, offerprice=0;
            obj = e.Item.FindControl("lblPrice");
            if (obj != null)
                lblPrice = (Label)obj;
            obj = e.Item.FindControl("lblOfferPrice");
            if (obj != null)
                lblOfferPrice = (Label)obj;
            obj = e.Item.FindControl("lblTitleOfferPrice");
            if (obj != null)
                lblTitleOfferPrice = (Label)obj;
            price = float.Parse(drv["SalePrice"].ToString());
            offerprice = float.Parse(drv["OfferPrice"].ToString());
            if (price > offerprice && offerprice>0)
            {
                if (lblPrice != null)
                    lblPrice.Font.Strikeout = true;
                if (lblOfferPrice != null)
                {
                    lblOfferPrice.Visible = true;
                    lblTitleOfferPrice.Visible = true;
                }
            }
            else 
            {
                if (lblOfferPrice != null)
                {
                    lblOfferPrice.Visible = false;
                    lblTitleOfferPrice.Visible = false;
                }
            }
        }
    }
}
