using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CompNetwork.BL;

public partial class ucShoppingCart : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            BindDataList();
        }
    }
    private void BindDataList()
    {
        DataSet ds=ShoppingCart.GetAllCartItems(Session.SessionID.ToString());
        if (ds.Tables[0].Rows.Count > 0)
        {
            dlCart.DataSource = ds;
            dlCart.DataBind();
            dlCart.Visible = true;
            lblMsg.Visible = false;
            lblTotal.Visible = true;
            lblTotal.Text = "Total Cart Amount: $ " + ShoppingCart.GetCartAmount(Session.SessionID).ToString();
        }
        else
        {
            dlCart.Visible = false;
            lblMsg.Visible = true;
            lblTotal.Visible=false;
            lblMsg.Text = "You have not shop any item or may be your sesion has been expired, please shop again.";
        }
    }
    private void selectDataListItems(bool status)
    {
        Object obj = null;
        CheckBox chk = null;
        try
        {
            foreach (DataListItem li in dlCart.Items)
            {
                obj = li.FindControl("chkbox");
                if (obj != null)
                {
                    chk = (CheckBox)obj;
                    chk.Checked = status;
                }
            }
        }
        catch (Exception ex)
        {
            lblMsg.Text = ex.Message;
        }
    }
    protected void ibtnSelectAll_Click1(object sender, EventArgs e)
    {
        if (ibtnSelectAll.Text == "Select All")
        {
            selectDataListItems(true);
            ibtnSelectAll.Text = "Deselect All";
        }
        else
        {
            selectDataListItems(false);
            ibtnSelectAll.Text = "Select All";
        }
    }
    protected void ibtnRemove_Click1(object sender, EventArgs e)
    {
        Object obj = null;
        CheckBox chk = null;
        Label lblPID = null;
        Label lblSessID = null;
        string SID = "";
        int PID = 0;
        try
        {
            foreach (DataListItem li in dlCart.Items)
            {
                obj = li.FindControl("chkbox");
                if (obj != null)
                {
                    chk = (CheckBox)obj;
                    if (chk.Checked == true)
                    {
                        obj = li.FindControl("lblSessionID");
                        if (obj != null)
                        {
                            lblSessID = (Label)obj;
                            SID = lblSessID.Text;
                        }
                        obj = li.FindControl("lblProductID");
                        if (obj != null)
                        {
                            lblPID = (Label)obj;
                            PID = int.Parse(lblPID.Text);
                        }
                        ShoppingCart.RemoveCartItem(SID, PID);
                    }
                }
            }
            BindDataList();
        }
        catch (Exception ex)
        {
            lblMsg.Text = ex.Message;
        }
    }
    protected void ibtnUpdateCart_Click1(object sender, EventArgs e)
    {
        Object obj = null;
        CheckBox chk = null;
        Label lblPID = null;
        Label lblSessID = null;
        TextBox txtQty = null;
        string SID = "";
        int PID = 0, Qty = 0;
        try
        {
            foreach (DataListItem li in dlCart.Items)
            {
                obj = li.FindControl("chkbox");
                if (obj != null)
                {
                    chk = (CheckBox)obj;
                    if (chk.Checked == true)
                    {
                        obj = li.FindControl("lblSessionID");
                        if (obj != null)
                        {
                            lblSessID = (Label)obj;
                            SID = lblSessID.Text;
                        }
                        obj = li.FindControl("lblProductID");
                        if (obj != null)
                        {
                            lblPID = (Label)obj;
                            PID = int.Parse(lblPID.Text);
                        }
                        obj = li.FindControl("txtQty");
                        if (obj != null)
                        {
                            txtQty = (TextBox)obj;
                            Qty = int.Parse(txtQty.Text);
                        }
                        ShoppingCart.UpdateCartItem(SID, PID, Qty);
                    }
                }
            }
            BindDataList();
        }
        catch (Exception ex)
        {
            lblMsg.Text = ex.Message;
        }
    }
    protected void ibtnShopMore_Click(object sender, EventArgs e)
    {
        Response.Redirect("~/Default.aspx");
    }
    protected void ibtnCheckOut_Click1(object sender, EventArgs e)
    {
        float oamt=0;
        int UID = 0,OID=0;
        object obj1=null;
        try
        {
            SqlParameter p=new SqlParameter("@Email",HttpContext.Current.User.Identity.Name);
            obj1= SqlHelper.ExecuteScalar(System.Configuration.ConfigurationManager.ConnectionStrings["EasyWearConnectionString"].ConnectionString, CommandType.StoredProcedure, "spGetUserIDByEmail", p);
            if (obj1 != null)
                int.TryParse(obj1.ToString(), out UID);
            if (float.TryParse(ShoppingCart.GetCartAmount(Session.SessionID).ToString(), out oamt))
            {
                SqlParameter[] p1 = new SqlParameter[3];
                p1[0]=new SqlParameter("@SID",Session.SessionID);
                p1[1]=new SqlParameter("@UID",UID);
                p1[2] = new SqlParameter("@TAmt", oamt);
                obj1 = SqlHelper.ExecuteScalar(System.Configuration.ConfigurationManager.ConnectionStrings["EasyWearConnectionString"].ConnectionString, CommandType.StoredProcedure, "spInsertOrders", p1);
                if (obj1 != null)
                    int.TryParse(obj1.ToString(), out OID);
            }
            else
                lblMsg.Text = "You have no item in your shopping cart";
            if (OID > 0)
                Session["OrderID"] = OID.ToString();
            Response.Redirect("~/Shipping/frmShipNBill.aspx?OrderID=" + OID.ToString());  
        }
        catch (Exception ex)
        { }
        
    }
}