using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CompNetwork.BL;

public partial class Registration_Controls_ucRegistration : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            BindCountries();
            BindStates();
            BindCities();
            BindGender();
            BindHintQuestion();
        }
    }
    private void BindCountries()
    {
        DataSet ds = Utility.GetAllCountries();
        BindDDL(ddlCountry, ds, "Name", "ID");
        ddlCountry.Items.Insert(0, "Select Country");
    }
    private void BindStates()
    {
        DataSet ds = Utility.GetAllStates();
        BindDDL(ddlState, ds, "Name", "ID");
        ddlState.Items.Insert(0, "Select State");
    }
    private void BindCities()
    {
        DataSet ds = Utility.GetAllCities();
        BindDDL(ddlCity, ds, "Name", "ID");
        ddlCity.Items.Insert(0, "Select City");
    }
    private void BindGender()
    {
        ddlGender.Items.Add(new ListItem("Male", "M"));
        ddlGender.Items.Add(new ListItem("Female", "F"));
        ddlGender.Items.Insert(0, new ListItem("Select Gender", "Select Gender"));
    }
    private void BindHintQuestion()
    {
        DataSet ds = Utility.GetAllHintQuestion();
        BindDDL(ddlHintQuestion, ds, "Question", "ID");
    }
    private void BindDDL(DropDownList ddl, DataSet ds, string txtField, string valField)
    {
        ddl.DataSource = ds;
        ddl.DataTextField = txtField;
        ddl.DataValueField = valField;
        ddl.DataBind();
    }
    //protected void IBtnRegister_Click(object sender, ImageClickEventArgs e)
    //{
    //    string fname,lname,gender,email,contactno,address,zip,uname,password,cPassword,answer="";
    //    int cityid, stateid, countryid, hintquestion=0,status=0;
    //    DateTime dob;
    //    //checking username
    //    if (txtUserName.Text.Trim() == "")
    //    {
    //        lblMsg.Text = "Enter Username";
    //        return;
    //    }
    //    else
    //        uname = txtUserName.Text.Trim();
    //    //checking Password
    //    if (txtPassword.Text.Trim() == "")
    //    {
    //        lblMsg.Text = "Enter Password";
    //        return;
    //    }
    //    else
    //        password = txtPassword.Text.Trim();
    //    //checking Confirm Password
    //    if (txtConfirmPassword.Text.Trim() == "")
    //    {
    //        lblMsg.Text = "Enter Confirm Password";
    //        return;
    //    }
    //    else
    //        cPassword = txtConfirmPassword.Text.Trim();
    //    //Comparing Passwords
    //    if (password!=cPassword)
    //    {
    //        lblMsg.Text = "Password Mismatch";
    //        return;
    //    }
    //    //checking Hint Question
    //    if (ddlHintQuestion.SelectedIndex>=0)
    //        hintquestion=int.Parse(ddlHintQuestion.SelectedValue.Trim());
        
    //    //checking Answer
    //    if (txtAnswer.Text.Trim() != "")
    //        answer = txtAnswer.Text.Trim();

    //    //checking firstname
    //    if (txtFName.Text.Trim() == "")
    //    {
    //        lblMsg.Text = "Enter Firstname";
    //        return;
    //    }
    //    else
    //        fname = txtFName.Text.Trim();

    //    //checking lastname
    //    if (txtLName.Text.Trim() == "")
    //    {
    //        lblMsg.Text = "Enter Lastname";
    //        return;
    //    }
    //    else
    //        lname = txtLName.Text.Trim();
        
    //    //checking gender
    //    if (ddlGender.SelectedIndex<=0)
    //    {
    //        lblMsg.Text = "Select Gender";
    //        return;
    //    }
    //    else
    //        gender = ddlGender.SelectedValue;

    //    //checking Date of birth
    //    dob = GMDateDOB.Date;
        
    //    //checking email
    //    if (txtEmailID.Text.Trim() == "")
    //    {
    //        lblMsg.Text = "Enter Alternate Email";
    //        return;
    //    }
    //    else
    //        email = txtEmailID.Text.Trim();

    //    //checking contactno
    //    if (txtContact.Text.Trim() == "")
    //    {
    //        lblMsg.Text = "Enter Contact No.";
    //        return;
    //    }
    //    else
    //        contactno = txtContact.Text.Trim();
    //    //checking address
    //    if (txtAddress.Text.Trim() == "")
    //    {
    //        lblMsg.Text = "Enter Address";
    //        return;
    //    }
    //    else
    //        address = txtAddress.Text.Trim();

    //    //checking Country
    //    if (ddlCountry.SelectedIndex <= 0)
    //    {
    //        lblMsg.Text = "Select Country";
    //        return;
    //    }
    //    else
    //        countryid = int.Parse(ddlCountry.SelectedValue);

    //    //checking State
    //    if (ddlState.SelectedIndex <= 0)
    //    {
    //        lblMsg.Text = "Select State";
    //        return;
    //    }
    //    else
    //        stateid = int.Parse(ddlState.SelectedValue);

    //    //checking City
    //    if (ddlCity.SelectedIndex <= 0)
    //    {
    //        lblMsg.Text = "Select City";
    //        return;
    //    }
    //    else
    //        cityid = int.Parse(ddlCity.SelectedValue);

    //    //checking Zipcode
    //    if (txtZip.Text.Trim() == "")
    //    {
    //        lblMsg.Text = "Enter Zipcode";
    //        return;
    //    }
    //    else
    //        zip = txtZip.Text.Trim();
    //    try
    //    {
    //        status = UserController.GetUserCountByUsername(uname);
    //        if (status >= 1)
    //        {
    //            lblMsg.Text = "Username not available, please select some different name";
    //            return;
    //        }
    //        else
    //        {
    //            status = UserController.RegisterUser(uname, password, hintquestion, answer, fname, lname, gender, dob, email, address, countryid, stateid, cityid, zip, contactno);
    //            if (status >= 1)
    //            {
    //                Response.Write("<script>alert('Registration Successful');</script>");
    //                FormsAuthentication.RedirectFromLoginPage(uname, false);
    //                lblMsg.Text = "Registration Successful";
    //            }
    //            else
    //                lblMsg.Text = "Registration failed";
    //        }
    //    }
    //    catch 
    //    {
    //        lblMsg.Text = "Registration failed";
    //    }
    //}
    protected void ddlSCountry_SelectedIndexChanged(object sender, EventArgs e)
    {
        DataSet ds = Utility.GetAllStatesByCountryID(int.Parse(ddlCountry.SelectedValue));
        BindDDL(ddlState, ds, "Name", "ID");
        ddlState.Items.Insert(0, "Select State");
    }
    protected void ddlSState_SelectedIndexChanged(object sender, EventArgs e)
    {
        DataSet ds = Utility.GetAllCitiesByStateID(int.Parse(ddlState.SelectedValue));
        BindDDL(ddlCity, ds, "Name", "ID");
        ddlCity.Items.Insert(0, "Select City");
    }
    protected void IBtnRegister_Click(object sender, EventArgs e)
    {
        string fname, lname, gender, email, contactno, address, zip, uname, password, cPassword, answer = "";
        int cityid, stateid, countryid, hintquestion = 0, status = 0;
        DateTime dob;
        //checking username
        if (txtUserName.Text.Trim() == "")
        {
            lblMsg.Text = "Enter Username";
            return;
        }
        else
            uname = txtUserName.Text.Trim();
        //checking Password
        if (txtPassword.Text.Trim() == "")
        {
            lblMsg.Text = "Enter Password";
            return;
        }
        else
            password = txtPassword.Text.Trim();
        //checking Confirm Password
        if (txtConfirmPassword.Text.Trim() == "")
        {
            lblMsg.Text = "Enter Confirm Password";
            return;
        }
        else
            cPassword = txtConfirmPassword.Text.Trim();
        //Comparing Passwords
        if (password != cPassword)
        {
            lblMsg.Text = "Password Mismatch";
            return;
        }
        //checking Hint Question
        if (ddlHintQuestion.SelectedIndex >= 0)
            hintquestion = int.Parse(ddlHintQuestion.SelectedValue.Trim());

        //checking Answer
        if (txtAnswer.Text.Trim() != "")
            answer = txtAnswer.Text.Trim();

        //checking firstname
        if (txtFName.Text.Trim() == "")
        {
            lblMsg.Text = "Enter Firstname";
            return;
        }
        else
            fname = txtFName.Text.Trim();

        //checking lastname
        if (txtLName.Text.Trim() == "")
        {
            lblMsg.Text = "Enter Lastname";
            return;
        }
        else
            lname = txtLName.Text.Trim();

        //checking gender
        if (ddlGender.SelectedIndex <= 0)
        {
            lblMsg.Text = "Select Gender";
            return;
        }
        else
            gender = ddlGender.SelectedValue;

        //checking Date of birth
        dob = GMDateDOB.Date;

        //checking email
        if (txtEmailID.Text.Trim() == "")
        {
            lblMsg.Text = "Enter Alternate Email";
            return;
        }
        else
            email = txtEmailID.Text.Trim();

        //checking contactno
        if (txtContact.Text.Trim() == "")
        {
            lblMsg.Text = "Enter Contact No.";
            return;
        }
        else
            contactno = txtContact.Text.Trim();
        //checking address
        if (txtAddress.Text.Trim() == "")
        {
            lblMsg.Text = "Enter Address";
            return;
        }
        else
            address = txtAddress.Text.Trim();

        //checking Country
        if (ddlCountry.SelectedIndex <= 0)
        {
            lblMsg.Text = "Select Country";
            return;
        }
        else
            countryid = int.Parse(ddlCountry.SelectedValue);

        //checking State
        if (ddlState.SelectedIndex <= 0)
        {
            lblMsg.Text = "Select State";
            return;
        }
        else
            stateid = int.Parse(ddlState.SelectedValue);

        //checking City
        if (ddlCity.SelectedIndex <= 0)
        {
            lblMsg.Text = "Select City";
            return;
        }
        else
            cityid = int.Parse(ddlCity.SelectedValue);

        //checking Zipcode
        if (txtZip.Text.Trim() == "")
        {
            lblMsg.Text = "Enter Zipcode";
            return;
        }
        else
            zip = txtZip.Text.Trim();
        try
        {
            status = UserController.GetUserCountByUsername(uname);
            if (status >= 1)
            {
                lblMsg.Text = "Username not available, please select some different name";
                return;
            }
            else
            {
                status = UserController.RegisterUser(uname, password, hintquestion, answer, fname, lname, gender, dob, email, address, countryid, stateid, cityid, zip, contactno);
                if (status >= 1)
                {
                    Response.Write("<script>alert('Registration Successful');</script>");
                    FormsAuthentication.RedirectFromLoginPage(uname, false);
                    lblMsg.Text = "Registration Successful";
                }
                else
                    lblMsg.Text = "Registration failed";
            }
        }
        catch
        {
            lblMsg.Text = "Registration failed";
        }
    }
}
