using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CompNetwork.BL;

public partial class Shipping_Controls_ucShipNBill : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            BindCountries();
            BindStates();
            BindCities();
            FillShippingAddress();
        }
    }

    private void BindCountries()
    {
        DataSet ds = Utility.GetAllCountries();
        BindDDL(ddlSCountry, ds, "Name", "ID");
        BindDDL(ddlBCountry, ds, "Name", "ID");
    }
    private void BindStates()
    {
        DataSet ds = Utility.GetAllStates();
        BindDDL(ddlSState, ds, "Name", "ID");
        BindDDL(ddlBState, ds, "Name", "ID");
    }
    private void BindCities()
    {
        DataSet ds = Utility.GetAllCities();
        BindDDL(ddlSCity, ds, "Name", "ID");
        BindDDL(ddlBCity, ds, "Name", "ID");
    }

    private void BindDDL(DropDownList ddl, DataSet ds, string txtField, string valField)
    {
        ddl.DataSource = ds;
        ddl.DataTextField = txtField;
        ddl.DataValueField = valField;
        ddl.DataBind();
    }
    private void FillShippingAddress()
    {
        DataSet ds;
        string username = HttpContext.Current.User.Identity.Name;
        if (username != "")
        {
            ds = UserController.GetUserAddress(username);
            if (ds.Tables[0].Rows.Count > 0)
            {
                BindShipAddress(ds.Tables[0]);
                EnableShipAddress(false);
            }
        }
    }

    private void BindShipAddress(DataTable dt)
    {
        txtSFName.Text = dt.Rows[0]["FirstName"].ToString();
        txtSLName.Text = dt.Rows[0]["LastName"].ToString();
        txtSEmailID.Text = dt.Rows[0]["EmailID"].ToString();
        txtSAddress.Text = dt.Rows[0]["Address"].ToString();
        txtSContact.Text = dt.Rows[0]["ContactNo"].ToString();
        ddlSCountry.Items.FindByValue(dt.Rows[0]["CountryID"].ToString()).Selected = true;
        ddlSState.Items.FindByValue(dt.Rows[0]["StateID"].ToString()).Selected = true;
        ddlSCity.Items.FindByValue(dt.Rows[0]["CityID"].ToString()).Selected = true;
        txtSZip.Text = dt.Rows[0]["ZIP"].ToString();
    }

    private void BindBillAddress(DataTable dt)
    {
        txtBFName.Text = dt.Rows[0]["FirstName"].ToString();
        txtBLName.Text = dt.Rows[0]["LastName"].ToString();
        txtBEmailID.Text = dt.Rows[0]["EmailID"].ToString();
        txtBAddress.Text = dt.Rows[0]["Address"].ToString();
        txtBContact.Text = dt.Rows[0]["ContactNo"].ToString();
        ddlBCountry.Items.FindByValue(dt.Rows[0]["CountryID"].ToString()).Selected = true;
        ddlBState.Items.FindByValue(dt.Rows[0]["StateID"].ToString()).Selected = true;
        ddlBCity.Items.FindByValue(dt.Rows[0]["CityID"].ToString()).Selected = true;
        txtBZip.Text = dt.Rows[0]["ZIP"].ToString();
    }

    private void EnableShipAddress(bool Status)
    {
        txtSFName.Enabled=Status;
        txtSLName.Enabled = Status;
        txtSEmailID.Enabled = Status;
        txtSAddress.Enabled = Status;
        txtSContact.Enabled = Status;
        ddlSCountry.Enabled = Status;
        ddlSState.Enabled = Status;
        ddlSCity.Enabled = Status;
        txtSZip.Enabled = Status;
    }

    private void EnableBillAddress(bool Status)
    {
        txtBFName.Enabled = Status;
        txtBLName.Enabled = Status;
        txtBEmailID.Enabled = Status;
        txtBAddress.Enabled = Status;
        txtBContact.Enabled = Status;
        ddlBCountry.Enabled = Status;
        ddlBState.Enabled = Status;
        ddlBCity.Enabled = Status;
        txtBZip.Enabled = Status;
    }

    protected void chkUpdateShippingAddress_CheckedChanged(object sender, EventArgs e)
    {
        if (chkUpdateShippingAddress.Checked == true)
            EnableShipAddress(true);
        else
            EnableShipAddress(false);
    }

    private void AssignShipAddressToBillAddress()
    {
        txtBFName.Text = txtSFName.Text;
        txtBLName.Text = txtSLName.Text;
        txtBEmailID.Text = txtSEmailID.Text;
        txtBAddress.Text = txtSAddress.Text;
        txtBContact.Text = txtSContact.Text;
        ddlBCountry.SelectedIndex = ddlSCountry.SelectedIndex;
        ddlBState.SelectedIndex = ddlSState.SelectedIndex;
        ddlBCity.SelectedIndex = ddlSCity.SelectedIndex;
        txtBZip.Text = txtSZip.Text;
    }
    protected void chkBilling_CheckedChanged(object sender, EventArgs e)
    {
        if (chkBilling.Checked == true)
        {
            AssignShipAddressToBillAddress();
            EnableBillAddress(false);
        }
        else
            EnableBillAddress(true);
    }
    protected void ddlSCountry_SelectedIndexChanged(object sender, EventArgs e)
    {
        DataSet ds=Utility.GetAllStatesByCountryID(int.Parse(ddlSCountry.SelectedValue));
        BindDDL(ddlSState, ds, "Name", "ID");
    }
    protected void ddlSState_SelectedIndexChanged(object sender, EventArgs e)
    {
        DataSet ds = Utility.GetAllCitiesByStateID(int.Parse(ddlSState.SelectedValue));
        BindDDL(ddlSCity, ds, "Name", "ID");
    }
    protected void ddlBCountry_SelectedIndexChanged(object sender, EventArgs e)
    {
        DataSet ds = Utility.GetAllStatesByCountryID(int.Parse(ddlBCountry.SelectedValue));
        BindDDL(ddlBState, ds, "Name", "ID");
    }
    protected void ddlBState_SelectedIndexChanged(object sender, EventArgs e)
    {
        DataSet ds = Utility.GetAllCitiesByStateID(int.Parse(ddlBState.SelectedValue));
        BindDDL(ddlBCity, ds, "Name", "ID");
    }
    protected void ibtnProceedToPayment_Click(object sender, EventArgs e)
    {
        UpdateShipBillAddress();
        Response.Redirect("~/payment/frmPayment.aspx");
    }
    private void UpdateShipBillAddress()
    {
        SqlParameter [] p = new SqlParameter[10];
        int OID=0;
        try
        {
            if(Request["OrderID"]!=null)
            int.TryParse(Request["OrderID"].ToString(),out OID);
            p[0]=new SqlParameter("@FName",txtBFName.Text);
            p[1]=new SqlParameter("@LName",txtBLName.Text);
            p[2]=new SqlParameter("@Email",txtBEmailID.Text);
            p[3]=new SqlParameter("@Address",txtBAddress.Text);
            p[4]=new SqlParameter("@City",ddlBCity.SelectedValue);
            p[5]=new SqlParameter("@State",ddlBState.SelectedValue);
            p[6]=new SqlParameter("@Country",ddlBCountry.SelectedValue);
            p[7]=new SqlParameter("@Zip",txtBZip.Text);
            p[8]=new SqlParameter("@ContactNo",txtBContact.Text);
            p[9]=new SqlParameter("@OrderID",OID);
            SqlHelper.ExecuteNonQuery(System.Configuration.ConfigurationManager.ConnectionStrings["EasyWearConnectionString"].ConnectionString, CommandType.StoredProcedure, "spInsertBillingAddress", p);

            p[0] = new SqlParameter("@FName", txtSFName.Text);
            p[1] = new SqlParameter("@LName", txtSLName.Text);
            p[2] = new SqlParameter("@Email", txtSEmailID.Text);
            p[3] = new SqlParameter("@Address", txtSAddress.Text);
            p[4] = new SqlParameter("@City", ddlSCity.SelectedValue);
            p[5] = new SqlParameter("@State", ddlSState.SelectedValue);
            p[6] = new SqlParameter("@Country", ddlSCountry.SelectedValue);
            p[7] = new SqlParameter("@Zip", txtSZip.Text);
            p[8] = new SqlParameter("@ContactNo", txtSContact.Text);
            p[9] = new SqlParameter("@OrderID", OID);
            SqlHelper.ExecuteNonQuery(System.Configuration.ConfigurationManager.ConnectionStrings["EasyWearConnectionString"].ConnectionString, CommandType.StoredProcedure, "spInsertShippingAddress", p);


        }
        catch (Exception ex)
        { }
    }
}
